<?php
///////////////////////////////////////////////////////////////////////////////
// vBulletin 2.2.x to phpBB 2.0 Convertor
///////////////////////////////////////////////////////////////////////////////
// Copyright:   Coding (C) 2002 Matthijs van de Water <matthijs@beryllium.net>
//              Portions of code (C) 2001 phpBB Group <support@phpbb.com>
//
//  $Id: import.php,v 1.01 2002/02/28 17:52:00 mvdwater Exp $
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// FILE DESCRIPTION:
///////////////////////////////////////////////////////////////////////////////
// This script will convert from an existing vBulletin 2.2.x installation 
// to a new phpBB 2.0 installation.
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// INSTALLATION GUIDELINES:
///////////////////////////////////////////////////////////////////////////////
// * Backup your files and database before attempting to run this conversion!
//   No change is made to your original vBulletin database, but one can never
//   be too carefull. The author and/or the phpBB Group are not responsible
//   for any data-loss as a result of using this software.
// * Do a clean install of phpBB 2.0.
// * Make sure smilie and avatar dirs are writable and executable 
//   for the webserver, as it needs to create directories and images.
// * Please verify the defines below and update them to your situation.
// * Place the import.php file in the vBulletin root dir.
// * Open the script in your browser and follow the onscreen instructions. Be
//   sure to take your time for the conversion, as the process may take several
//   hours, depending on the size of your board and the speed of your server.
// * Go make some coffee.
///////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////
// Conversion Tool Configuration Settings
///////////////////////////////////////////////////////////////////////////////

// Global path defines, change this if your installation is different
define ("VBULLETIN_PATH", "./");
define ("PHPBB_PATH", "../phpBB/");
define ("PHPBB_URI", "http://localhost/phpBB/");

// Do this many items in one go
$batchsize = 1000;

///////////////////////////////////////////////////////////////////////////////
// NO NEED TO CHANGE ANYTHING BELOW THIS LINE
///////////////////////////////////////////////////////////////////////////////

// Check if paths defined above are correct
if (!@file_exists(VBULLETIN_PATH . 'global.php')) {
  die("ERROR: Unable to find vBulletin global.php include.<br />Check path defines.<br />");
}
if (!@file_exists(PHPBB_PATH . 'extension.inc')) {
  die("ERROR: Unable to find phpBB includes.<br />Check path defines.<br />");
}

// Unlimited execution time
set_time_limit(0);

// Use no caching headers in vBulletin global config
$nocacheheaders = true;

// Include vBulletin configuration files
include(VBULLETIN_PATH . 'global.php');

// Use our own error reporting
$DB_site->reporterror = 0;

// Include phpBB config and global files and needed functions
$phpbb_root_path = PHPBB_PATH;
include(PHPBB_PATH . 'extension.inc');
include(PHPBB_PATH . 'common.' . $phpEx);
include(PHPBB_PATH . 'includes/post.' . $phpEx);
include(PHPBB_PATH . 'includes/bbcode.' . $phpEx);
include(PHPBB_PATH . 'includes/search.'.$phpEx);

///////////////////////////////////////////////////////////////////////////////
// Functions for use in this file
///////////////////////////////////////////////////////////////////////////////

// Dies with a nicely formatted error message
function die_nice($message) {
  print "<br /><br /><span class=\"error\">ERROR</span>: $message<br /><br />\n";
  print "After you have located and fixed the error, reload this page to continue the conversion process.<br />\n";
  print mysql_error();
  common_footer();
  exit;
}

// Converts [quote], [php], [font] tags
function convert_vb_code ($bbcode, $quote_template = -1) {
  // remove [font] tags
  $search = array("|\[font=[^\]]*\]|si","|\[/font\]|si");
  $replace = array("","");
  $bbcode = preg_replace($search,$replace,$bbcode);
  
  // convert [php] tag to [code]
  $search = array("[php]","[/php]","[PHP]","[/PHP]");
  $replace = array("[code]","[/code]","[code]","[/code]");
  $bbcode = str_replace($search,$replace,$bbcode);
  
  // convert [size] tags
  $search = "/\[size=([0-9]+)\]/ie";
  $replace = "'[size='.( (\\1 == 1) ? 9 : 6*\\1 ).']'";
  $bbcode = preg_replace($search,$replace,$bbcode);
  
  // convert [quote] structure (use specified template)
  if ($quote_template != -1) {
    if (preg_match("/(\[quote\].*\[\/quote\])/si",$bbcode,$match)) {
      $quote_text = $match[1];
      $search = $quote_template;
      $replace = array("[quote=\"\\1\"]\n","[/quote]");
    
      $quote_text = preg_replace($search,$replace,$quote_text);
      $bbcode = preg_replace("/(\[quote\].*\[\/quote\])/si",$quote_text,$bbcode);
    }
  }

  return $bbcode;
}

// Locks tables we're working on - modified from upgrade.php
function lock_tables($state, $tables= '')
{
  global $DB_site;
  
	if ( $state == 1 )
	{
		if ( is_array($tables) )
		{
			$tables = join(' WRITE, ', $tables);
		}

		$DB_site->query("LOCK TABLES $tables WRITE") or die_nice("Unable to do LOCK TABLES $tables WRITE");
	}
	else
	{
		$DB_site->query("UNLOCK TABLES") or die_nice("Unable to unlock tables");
	}
}

// Print common page header - modified from upgrade.php
function common_header()
{
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<title>vBulletin 2.2.x Conversion Tool for phpBB 2.0</title>
<meta name="description" content="vBulletin 2.2.x to phpBB 2.0 Conversion Tool">
<meta name="keywords" content="phpbb 2.0 vbulletin 2.2.2 2.2.1 2.2.x conversion tool">
<meta name="author" content="Matthijs van de Water">
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1">
<meta http-equiv="Content-Style-Type" content="text/css">
<style type="text/css">
<!--
/* Specifiy background images for selected styles
   This can't be done within the external style sheet as NS4 sees image paths relative to
   the page which called the style sheet (i.e. this page in the root phpBB directory)
   whereas all other browsers see image paths relative to the style sheet. Stupid NS again!
*/
TH			{ background-image: url(<?php print PHPBB_URI; ?>templates/subSilver/images/cellpic3.gif) }
TD.cat		{ background-image: url(<?php print PHPBB_URI; ?>templates/subSilver/images/cellpic1.gif) }
TD.rowpic	{ background-image: url(<?php print PHPBB_URI; ?>templates/subSilver/images/cellpic2.jpg); background-repeat: repeat-y }
td.icqback	{ background-image: url(<?php print PHPBB_URI; ?>templates/subSilver/images/icon_icq_add.gif); background-repeat: no-repeat }
TD.catHead,TD.catSides,TD.catLeft,TD.catRight,TD.catBottom { background-image: url(<?php print PHPBB_URI; ?>templates/subSilver/images/cellpic1.gif) }

font,th,td,p,body { font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 11pt }
a:link,a:active,a:visited { font-family: Verdana, Arial, Helvetica, sans-serif; color : #006699; font-size:11pt }
a:hover		{ font-family: Verdana, Arial, Helvetica, sans-serif;  text-decoration: underline; color : #DD6900; font-size:11pt }
hr	{ height: 0px; border: solid #D1D7DC 0px; border-top-width: 1px;}

.maintitle,h1,h2	{font-weight: bold; font-size: 22px; font-family: "Trebuchet MS",Verdana, Arial, Helvetica, sans-serif; text-decoration: none; line-height : 120%; color : #000000;}

.copyright		{ font-size: 10px; font-family: Verdana, Arial, Helvetica, sans-serif; color: #444444; letter-spacing: -1px;}
a.copyright		{ font-size: 10px; font-family: Verdana, Arial, Helvetica, sans-serif; color: #444444; text-decoration: none;}
a.copyright:hover { font-size: 10px; font-family: Verdana, Arial, Helvetica, sans-serif; color: #000000; text-decoration: underline;}
a.copyright:visited { font-size: 10px; font-family: Verdana, Arial, Helvetica, sans-serif; color: #444444; }

.ok { color:green; }
.error { color:red; font-weight: bold; }

/* Import the fancy styles for IE only (NS4.x doesn't use the @import function) */
@import url("<?php print PHPBB_URI; ?>templates/subSilver/formIE.css"); 
-->
</style>
</head>
<body bgcolor="#FFFFFF" text="#000000" link="#006699" vlink="#5584AA">

<table width="100%" border="0" cellspacing="0" cellpadding="10" align="center"> 
	<tr>
		<td><table width="100%" border="0" cellspacing="0" cellpadding="0">
			<tr>
				<td><img src="<?php print PHPBB_URI; ?>templates/subSilver/images/logo_phpBB.gif" border="0" alt="phpBB 2.0" vspace="1" /></td>
				<td align="center" width="100%" valign="middle"><span class="maintitle">Converting to phpBB 2.0</span><br />vBulletin 2.2.x conversion tool by Matthijs van de Water</span></td>
			</tr>
		</table></td>
	</tr>
</table>

<br clear="all" />

<?php
	return;
}

// Print common page footer - modified from upgrade.php
function common_footer()
{
?>

<br clear="all" />
<br />

<div align="center"><span class="copyright">
Conversion tool &copy; 2002 <a href="http://matthijs.beryllium.net/" target="_mvdw" class="copyright">Matthijs van de Water</a><br />
phpBB 2.0 and portions of code &copy; 2001 <a href="http://www.phpbb.com/" target="_phpbb" class="copyright">phpBB Group</a><br />
vBulletin &copy; 2000-2002 <a href="http://www.jelsoft.com/" target="_vb" class="copyright">Jelsoft Enterprises Limited</a><br />
</span></div>

</body>
</html>
<?php
	return;
}

// Print next step HTML
function next_step($next) {
  global $step;
  
  if ($step != "all") {
	  print "<hr /><a href=\"$PHP_SELF?step=$next\">Next step: <b>$next</b></a><br /><br />\n";
	  common_footer();
	}
}

///////////////////////////////////////////////////////////////////////////////

// Display welcome screen if the user hasn't specified a specific starting point.
$step = ( isset($HTTP_GET_VARS['step']) ) ? $HTTP_GET_VARS['step'] : 'start';

// Output common header
common_header();

///////////////////////////////////////////////////////////////////////////////
// INITIAL SCREEN
///////////////////////////////////////////////////////////////////////////////
if ($step == "start") {
  // Show HTML welcome screen
  print "<b>Welcome to the vBulletin 2.2.x to phpBB 2.0 import script.</b><br /><br />\n";
  print "This script will guide you through the import process. Depending on the size of your board and the speed of your server the process can last over an hour, so be patient.<br />\n";
  print "Don't interrupt the loading of pages, follow the instructions on screen.<br />\n";
  print "<br /><span class=\"error\">Be sure to backup your databases before continuing!</span><br />\n";
  print "<br /><br /><br /><br />\n";
  print "<hr /><a href=\"$PHP_SELF?step=settings\">Start import</a><br /><br />\n";
  common_footer();
}

///////////////////////////////////////////////////////////////////////////////
// CONVERT SETTINGS
///////////////////////////////////////////////////////////////////////////////
if ($step == "all" or $step == "settings") {
  print "* Importing configuration settings :: ";
  flush();

  // Private message quota
  $pmsentbox = $pmquota;
  $pmsavebox = $pmquota;
  $pminbox = $pmquota;
  
  $floodchecktime = ($enablefloodcheck) ? $floodchecktime : 0;
  $dateformat .= " $timeformat";
  
  // Patch timezone offset
  if ($timeoffset > 0) {
    $timeoffset = "+".$timeoffset;
  }
  // Get max online users and date/time
  list($maxusers,$maxuserstime) = explode(" ", gettemplate('maxloggedin',0,0));
  
  // Activation type
  $activation = ($verifyemail) ? USER_ACTIVATION_SELF : USER_ACTIVATION_NONE;
  $activation = ($moderatenewmembers) ? USER_ACTIVATION_ADMIN : $activation;
  
  $sql = array();

  // Updates
  $sql[] = "UPDATE " . CONFIG_TABLE . " SET config_value = '" . !$bbactive . "' WHERE config_name = 'board_disable'";
  $sql[] = "UPDATE " . CONFIG_TABLE . " SET config_value = '" . addslashes($bbtitle) . "' WHERE config_name = 'sitename'";
  $sql[] = "UPDATE " . CONFIG_TABLE . " SET config_value = 'vBulletin 2.2.x Converted Board' WHERE config_name = 'site_desc'";
  $sql[] = "UPDATE " . CONFIG_TABLE . " SET config_value = '" . addslashes($cookiepath) . "' WHERE config_name = 'cookie_path'";
  $sql[] = "UPDATE " . CONFIG_TABLE . " SET config_value = '" . addslashes($cookiedomain) . "' WHERE config_name = 'cookie_domain'";
  $sql[] = "UPDATE " . CONFIG_TABLE . " SET config_value = '" . $cookietimeout . "' WHERE config_name = 'session_length'";
  $sql[] = "UPDATE " . CONFIG_TABLE . " SET config_value = '" . $allowhtml . "' WHERE config_name = 'allow_html'";
  $sql[] = "UPDATE " . CONFIG_TABLE . " SET config_value = '" . $allowbbcode . "' WHERE config_name = 'allow_bbcode'";
  $sql[] = "UPDATE " . CONFIG_TABLE . " SET config_value = '" . $allowsmilies . "' WHERE config_name = 'allow_smilies'";
  $sql[] = "UPDATE " . CONFIG_TABLE . " SET config_value = '" . $allowsignatures . "' WHERE config_name = 'allow_sig'";
  $sql[] = "UPDATE " . CONFIG_TABLE . " SET config_value = '" . $avatarallowupload . "' WHERE config_name = 'allow_avatar_local'";
  $sql[] = "UPDATE " . CONFIG_TABLE . " SET config_value = '" . $avatarallowwebsite . "' WHERE config_name = 'allow_avatar_remote'";
  $sql[] = "UPDATE " . CONFIG_TABLE . " SET config_value = '" . $avatarallowupload . "' WHERE config_name = 'allow_avatar_upload'";
  $sql[] = "UPDATE " . CONFIG_TABLE . " SET config_value = '" . $maxposts . "' WHERE config_name = 'posts_per_page'";
  $sql[] = "UPDATE " . CONFIG_TABLE . " SET config_value = '" . $maxthreads . "' WHERE config_name = 'topics_per_page'";
  $sql[] = "UPDATE " . CONFIG_TABLE . " SET config_value = '" . $hotnumberposts . "' WHERE config_name = 'hot_threshold'";
  $sql[] = "UPDATE " . CONFIG_TABLE . " SET config_value = '" . $maxpolloptions . "' WHERE config_name = 'max_poll_options'";
  $sql[] = "UPDATE " . CONFIG_TABLE . " SET config_value = '" . $pminbox . "' WHERE config_name = 'max_inbox_privmsgs'";
  $sql[] = "UPDATE " . CONFIG_TABLE . " SET config_value = '" . $pmsentbox . "' WHERE config_name = 'max_sentbox_privmsgs'";
  $sql[] = "UPDATE " . CONFIG_TABLE . " SET config_value = '" . $pmsavebox . "' WHERE config_name = 'max_savebox_privmsgs'";
  $sql[] = "UPDATE " . CONFIG_TABLE . " SET config_value = '" . addslashes($webmasteremail) . "' WHERE config_name = 'board_email'";
  $sql[] = "UPDATE " . CONFIG_TABLE . " SET config_value = '" . $activation . "' WHERE config_name = 'require_activation'";
  $sql[] = "UPDATE " . CONFIG_TABLE . " SET config_value = '" . $floodchecktime . "' WHERE config_name = 'flood_interval'";
  $sql[] = "UPDATE " . CONFIG_TABLE . " SET config_value = '" . $secureemail . "' WHERE config_name = 'board_email_form'";
  $sql[] = "UPDATE " . CONFIG_TABLE . " SET config_value = '" . $avatarmaxsize . "' WHERE config_name = 'avatar_filesize'";
  $sql[] = "UPDATE " . CONFIG_TABLE . " SET config_value = '" . $avatarmaxdimension . "' WHERE config_name = 'avatar_max_width'";
  $sql[] = "UPDATE " . CONFIG_TABLE . " SET config_value = '" . $avatarmaxdimension . "' WHERE config_name = 'avatar_max_height'";
  $sql[] = "UPDATE " . CONFIG_TABLE . " SET config_value = '" . $dateformat . "' WHERE config_name = 'default_dateformat'";
  $sql[] = "UPDATE " . CONFIG_TABLE . " SET config_value = '" . $timeoffset . "' WHERE config_name = 'board_timezone'";
  $sql[] = "UPDATE " . CONFIG_TABLE . " SET config_value = '" . !$enablepms . "' WHERE config_name = 'privmsg_disable'"; 
  $sql[] = "UPDATE " . CONFIG_TABLE . " SET config_value = '" . $gzipoutput . "' WHERE config_name = 'gzip_compress'";
  $sql[] = "UPDATE " . CONFIG_TABLE . " SET config_value = '" . $faxnumber . "' WHERE config_name = 'coppa_fax'";
  $sql[] = "UPDATE " . CONFIG_TABLE . " SET config_value = '" . $address . "' WHERE config_name = 'coppa_mail'";
  $sql[] = "UPDATE " . CONFIG_TABLE . " SET config_value = '" . $maxusers . "' WHERE config_name = 'record_online_users'";
  $sql[] = "UPDATE " . CONFIG_TABLE . " SET config_value = '" . $maxuserstime . "' WHERE config_name = 'record_online_date'";
  
  @reset($sql);
  while ($query = each($sql)) {
    $db->sql_query($query[1]) or die_nice("Unable to update config table (".$query[0].")");
  }
  unset($sql);
  print " <span class=\"ok\"><b>OK</b></span><br />\n";

  // update board config (this is only usefull when using the step=all option
  $board_config['allow_html'] = $allowhtml;
  $board_config['allow_bbcode'] = $allowbbcode;
  $board_config['allow_smilies'] = $allowsmilies;
  $board_config['allow_sig'] = $allowsignatures;
  $board_config['allow_avatar_local'] = $avatarallowupload;
  $board_config['allow_avatar_remote'] = $avatarallowwebsite;
  $board_config['allow_avatar_upload'] = $avatarallowupload;

  // ranks
  print "* Converting ranks :: ";
  $db->sql_query("DELETE FROM " . RANKS_TABLE) or die_nice("Delete ranks from table ".RANKS_TABLE." failed");
  $ranks_query = $DB_site->query("SELECT * FROM usertitle") or die_nice("Unable to query ranks");
  while ($rank = $DB_site->fetch_array($ranks_query)) {
    $title = addslashes($rank['title']);
    $min = $rank['minposts'];
    $db->sql_query("INSERT INTO " . RANKS_TABLE . " (rank_title, rank_min) VALUES ('$title',$min)") or die_nice("Unable to insert rank '$title'");
  }
  print " <span class=\"ok\"><b>OK</b></span><br />\n";

  // censor words
  print "* Converting censored words :: ";
  flush();
  $words = explode(" ",$censorwords);
  $sql = "INSERT IGNORE INTO " . WORDS_TABLE . " (word, replacement) VALUES ";
  $count = 0;
  while (list($i,$word) = each($words)) {
    $word = strtolower(trim($word));
    if (ereg("^\{.*\}$",$word)) {
      $word = substr($word,1,-1);
      $replacement = str_repeat($censorchar, strlen($word));
    }
    else {
      $replacement = str_repeat($censorchar, strlen($word));
      $word = "*$word*";
    }
    if (strlen($replacement) > 1) {
      $sql .= "('" . str_replace("\'", "''", $word) . "', '" . $replacement . "'),";
      $count++;
    }
  }
  if ($count) {
    $sql = substr($sql,0,-1);
    $db->sql_query($sql) or die_nice("Unable to insert disallowed usernames");
  }
  print " <span class=\"ok\"><b>OK</b></span><br />\n";

  // illegal usernames
  print "* Converting disallowed usernames :: ";
  flush();
  $db->sql_query("DELETE FROM ". DISALLOW_TABLE) or die_nice("Unable to empty disallowed usernames");
  $usernames = explode(" ",$illegalusernames);
  $sql = "INSERT IGNORE INTO " . DISALLOW_TABLE . " (disallow_username) VALUES ";
  $count = 0;
  while (list($i,$username) = each($usernames)) {
    $username = strtolower(trim($username));
    if (strlen($username) > 1) {
       $sql .= "('".addslashes($username)."'),";
       $count++;
    }
  }
  if ($count) {
    $sql = substr($sql,0,-1);
    $db->sql_query($sql) or die_nice("Unable to insert disallowed usernames");
  }
  print " <span class=\"ok\"><b>OK</b></span><br />\n";
  
  // ban-list
  $db->sql_query("DELETE FROM " . BANLIST_TABLE) or die_nice("Unable to empty banlist table");
  
  // IP addresses
	print "* Converting banned IPs :: ";
	flush();
	$ip_list_temp = explode(" ", $banip);
	$sql = "INSERT IGNORE INTO " . BANLIST_TABLE . " (ban_ip) VALUES ";
	for($i = 0; $i < count($ip_list_temp); $i++) {
	  $dots = substr_count($ip_list_temp[$i],".");
	  while ($dots != 3) {
	    $ip_list_temp[$i] .= ".255";
	    $dots++;
	  }
	  $ip = encode_ip($ip_list_temp[$i]);
	  $sql .= "('$ip'),";
	}
	if (count($ip_list_temp)) {
	  $sql = substr($sql,0,-1);
    $db->sql_query($sql) or die_nice("Unable to insert banned IPs");
  }
  print " <span class=\"ok\"><b>OK</b></span><br />\n";
  
  // Email addresses
  print "* Converting banned emailaddresses :: ";
  flush();
  $ban_mail_temp = explode(" ", $banemail);
  $sql = "INSERT IGNORE INTO " . BANLIST_TABLE . " (ban_email) VALUES ";
  while (list($i,$email) = each($ban_mail_temp)) {
    $email = strtolower(trim($email));
    if (substr($email,0,1) == "@") {
      $email = "*".$email;
    }
    $sql .= "('$email'),";
  }
  if (count($ban_mail_temp)) {
    $sql = substr($sql,0,-1);
    $db->sql_query($sql) or die_nice("Unable to insert banned email addresses");
  }
  print " <span class=\"ok\"><b>OK</b></span><br />\n";
  
  //
  // Convert smilies and generate smilie packs
  //

	// check if smilie dir is writable
	if (is_writable(PHPBB_PATH . $board_config['smilies_path']) . '/') {

    print "* Generating smilie pack from vBulletin smilies :: ";

    $delimeter  = '=+:';
  
   	//
  	// Export our current smiley config as a smiley pak...
  	//
  	$sql = "SELECT * FROM " . SMILIES_TABLE;
  	$result = $db->sql_query($sql) or die_nice("Couldn't query current smilies");
  
  	$resultset = $db->sql_fetchrowset($result);
  
  	$smile_pak = "";
  	for($i = 0; $i < count($resultset); $i++ )
  	{
  		$smile_pak .= $resultset[$i]['smile_url'] . $delimeter;
  		$smile_pak .= $resultset[$i]['emoticon'] . $delimeter;
  		$smile_pak .= $resultset[$i]['code'] . "\n";
  	}
    
    $fp = fopen (PHPBB_PATH . $board_config['smilies_path'] . '/phpbb2_original_smilies.pak', 'wb');
    $written = fwrite($fp, $smile_pak);
    fclose($fp);
    if ($written != strlen($smile_pak)) {
      @unlink(PHPBB_PATH . $board_config['smilies_path'] . '/phpbb2_original_smilies.pak');
      print "<br /> &nbsp;&nbsp;&nbsp; <b>Warning</b>: error writing smilie pack, skipping smilie import.<br />";
    }
    else {
      // old smilie pack written
      // build smilie pack from vB smilies and save it, copy smilies to new location
      // store only non-existing smilies in the database
      $vb_smile_pak = "";
      $no_copy = false;

      $smilie_query = $DB_site->query("SELECT * FROM smilie") or die_nice("Unable to query smilie info");
      while ($smilie = $DB_site->fetch_array($smilie_query)) {
        
        $filename = basename($smilie['smiliepath']);
        $new_file = "vb_" . $filename;
        
        $copy_from = VBULLETIN_PATH . $smilie['smiliepath'];
        $copy_to = PHPBB_PATH . $board_config['smilies_path'] . '/' . $new_file;
        if (!$no_copy) {
          if (!@copy($copy_from,$copy_to)) {
            print "<br /> &nbsp;&nbsp;&nbsp; <b>Warning</b>: error copying smilies, copy them by hand.<br />";
            $no_copy = true;
          }
        }
        
    		$vb_smile_pak .= $new_file . $delimeter;
    		$vb_smile_pak .= $smilie['title'] . $delimeter;
    		$vb_smile_pak .= $smilie['smilietext'] . "\n";
    		
    		// check if smilie exists
    		$sql = "SELECT smilies_id FROM " . SMILIES_TABLE . " WHERE code = '".addslashes($smilie['smilietext'])."'";
    		$exists = $db->sql_query($sql) or die_nice("Unable to query existing smilie");
    		if (!$db->sql_numrows($exists)) {
    		  // smilie does not yet exist, insert
      		$sql = "INSERT INTO " . SMILIES_TABLE . " (code, smile_url, emoticon) 
      		        VALUES ('".addslashes($smilie['smilietext'])."','".$new_file."','".addslashes($smilie['title'])."')";
      		$db->sql_query($sql) or die_nice("Unable to insert smilie (".$smilie['smilietext'].")");
    		}
    		
      }
      
      $fp = fopen (PHPBB_PATH . $board_config['smilies_path'] . '/vb_imported_smilies.pak', 'wb');
      $written = fwrite($fp, $vb_smile_pak);
      fclose($fp);
      if ($written != strlen($vb_smile_pak)) {
        @unlink(PHPBB_PATH . $board_config['smilies_path'] . '/vb_imported_smilies.pak');
        print "<br /> &nbsp;&nbsp;&nbsp; <b>Warning</b>: error writing vB smilie pack.<br />";
      }
    }
    print " <span class=\"ok\"><b>OK</b></span><br />\n";
	}
	else {
	  // some day I may put some code here to download the smilie pack
	  // for now, we just forget about the smilies
	  // user should make sure dir has correct permissions
	  // be sure to include that in the manual 
	  print "* <span class=\"error\">Skipping smilies, smilie dir not writable</span><br />";
	}
	
  //
	// Convert Avatar Gallery
	//
	$failed = false;
	if (is_writable(PHPBB_PATH . $board_config['avatar_gallery_path']) . '/') {

    print "* Generating Avatar Gallery from vBulletin Avatars :: ";
    flush();
    $avatar_query = $DB_site->query("SELECT avatarpath FROM avatar") or die_nice("Unable to query avatar data");
    while ($avatar = $DB_site->fetch_array($avatar_query)) {
      // strip beginning 'images/avatars/'
      // ignore avatars outside images/avatars dir for the moment
      // people with normal installations shouldn't have any problems
      if (substr($avatar['avatarpath'],0,15) == 'images/avatars/') {
        $path = substr($avatar['avatarpath'],15);
        $dirname = dirname($path);
        if ($dirname == ".") {
          $dirname = "default";
        }
        $filename = basename($path);
        if (!@file_exists(PHPBB_PATH . $board_config['avatar_gallery_path'] . '/' . $dirname . '/')) {
          // create dir
          if (!@mkdir(PHPBB_PATH . $board_config['avatar_gallery_path'] . '/' . $dirname)) {
            // dir creation failed... skip gallery import
            $failed = true;
            break;
          }
        }
        @copy(VBULLETIN_PATH . $avatar['avatarpath'], PHPBB_PATH . $board_config['avatar_gallery_path'] . '/' . $dirname . '/' . $filename);
      }
    }
  }
  else {
    // Avatar Gallery not writable
    $failed = true;
    // print "* <span class=\"error\">Skipping Gallery Avatars, avatar dir not writable</span><br />";
  }	
  if ($failed) {
    print "<span class=\"error\">FAILED</span><br />\n";
  }
  else {
    print " <span class=\"ok\"><b>OK</b></span><br />\n";
  }

  next_step("forums");
}

///////////////////////////////////////////////////////////////////////////////
// CONVERT FORUMS
///////////////////////////////////////////////////////////////////////////////
if ($step == "all" or $step == "forums") {
  print "* Deleting existing forums and categories :: ";
  flush();
  $db->sql_query("DELETE FROM " . FORUMS_TABLE) or die_nice("Unable to delete old forums");
  $db->sql_query("DELETE FROM " . CATEGORIES_TABLE) or die_nice("Unable to delete old categories");
  $db->sql_query("DELETE FROM " . GROUPS_TABLE . " WHERE group_id <> 1") or die_nice("Unable to delete old groups");
  $db->sql_query("DELETE FROM " . AUTH_ACCESS_TABLE . " WHERE group_id <> 1") or die_nice("Unable to delete access rights");
  print " <span class=\"ok\"><b>OK</b></span><br />\n";

  print "* Converting categories :: ";
  flush();

  $sql = "SELECT forumid,title,displayorder,parentid,parentlist FROM forum WHERE cancontainthreads=0 ORDER BY parentid,displayorder";
  $category_query = $DB_site->query($sql) or die_nice("Unable to query category information");
  $categories = array();
  $display_order = 0;
  while ($category = $DB_site->fetch_array($category_query)) {
    $categories[$category['forumid']] = $category;
    $display_order++;
    $sql = "INSERT INTO " . CATEGORIES_TABLE . " (cat_title, cat_order) VALUES ('".addslashes($category['title'])."',$display_order)";
    $db->sql_query($sql) or die_nice("Unable to insert category (".$category['title'].")");
    $categories[$category['forumid']]['cat_id'] = $db->sql_nextid();
  }
  print " <span class=\"ok\"><b>OK</b></span><br />\n";

  print "* Converting forums and permissions :: ";
  flush();

  // Get standard usergroup permissions
  $sql = "SELECT * FROM usergroup WHERE usergroupid IN (1,2) ORDER BY usergroupid";
  $permission_query = $DB_site->query($sql) or die_nice("Unable to query default usergroup permissions");
  $auth = array();
  while ($perm = $DB_site->fetch_array($permission_query)) {
    if ($perm['usergroupid'] == 1) {
      $auth['view'] = ($perm['canview']) ? AUTH_ALL : AUTH_REG;
      $auth['read'] = $auth['view'];
      $auth['post'] = ($perm['canpostnew']) ? AUTH_ALL : AUTH_REG;
      $auth['reply'] = ($perm['canreplyothers']) ? AUTH_ALL : AUTH_REG;
      $auth['edit'] = ($perm['caneditpost']) ? AUTH_ALL : AUTH_REG;
      $auth['delete'] = ($perm['candeletepost']) ? AUTH_ALL : AUTH_REG;
      $auth['vote'] = ($perm['canvote']) ? AUTH_ALL : AUTH_REG;
      $auth['pollcreate'] = ($perm['canpostpoll']) ? AUTH_ALL : AUTH_REG;
      $auth['attachments'] = ($perm['canpostattachment']) ? AUTH_ALL : AUTH_REG;
    }
    else {
      $auth['view'] = ($perm['canview']) ? $auth['view'] : AUTH_MOD;
      $auth['read'] = $auth['view'];
      $auth['post'] = ($perm['canpostnew']) ? $auth['post'] : AUTH_MOD;
      $auth['reply'] = ($perm['canreplyothers']) ? $auth['reply'] : AUTH_MOD;
      $auth['edit'] = ($perm['caneditpost']) ? $auth['edit'] : AUTH_MOD;
      $auth['delete'] = ($perm['candeletepost']) ? $auth['delete'] : AUTH_MOD;
      $auth['vote'] = ($perm['canvote']) ? $auth['vote'] : AUTH_MOD;
      $auth['pollcreate'] = ($perm['canpostpoll']) ? $auth['pollcreate'] : AUTH_MOD;
      $auth['attachments'] = ($perm['canpostattachment']) ? $auth['attachments'] : AUTH_MOD;
    }
  }
  // sticky and announce only for MODs
  $auth['sticky'] = AUTH_MOD;
  $auth['announce'] = AUTH_MOD;

  $sql = "SELECT * FROM forum WHERE cancontainthreads<>0 ORDER BY parentid,displayorder";
  $forums_query = $DB_site->query($sql) or die_nice("Unable to query forum information");
  while ($forum = $DB_site->fetch_array($forums_query)) {
    $forum_status = ($forum[allowposting]) ? FORUM_UNLOCKED : FORUM_LOCKED;
    
    // this implementation of categories will only work if parent of forum is always a category
    $catid = $categories[$forum['parentid']]['cat_id'];
    
    // get custom forum permissions
    $sql = "SELECT * FROM forumpermission WHERE forumid=".$forum['forumid']." AND usergroupid IN (1,2) ORDER BY usergroupid";
    $permission_query = $DB_site->query($sql) or die_nice("Unable to query forum permissions for forum ".$forum['forumid']);
    while ($perm = $DB_site->fetch_array($permission_query)) {
      if ($perm['usergroupid'] == 1) {
        $auth['view'] = ($perm['canview']) ? AUTH_ALL : AUTH_REG;
        $auth['read'] = $auth['view'];
        $auth['post'] = ($perm['canpostnew']) ? AUTH_ALL : AUTH_REG;
        $auth['reply'] = ($perm['canreplyothers']) ? AUTH_ALL : AUTH_REG;
        $auth['edit'] = ($perm['caneditpost']) ? AUTH_ALL : AUTH_REG;
        $auth['delete'] = ($perm['candeletepost']) ? AUTH_ALL : AUTH_REG;
        $auth['vote'] = ($perm['canvote']) ? AUTH_ALL : AUTH_REG;
        $auth['pollcreate'] = ($perm['canpostpoll']) ? AUTH_ALL : AUTH_REG;
        $auth['attachments'] = ($perm['canpostattachment']) ? AUTH_ALL : AUTH_REG;
      }
      else {
        $auth['view'] = ($perm['canview']) ? $auth['view'] : AUTH_MOD;
        $auth['read'] = $auth['view'];
        $auth['post'] = ($perm['canpostnew']) ? $auth['post'] : AUTH_MOD;
        $auth['reply'] = ($perm['canreplyothers']) ? $auth['reply'] : AUTH_MOD;
        $auth['edit'] = ($perm['caneditpost']) ? $auth['edit'] : AUTH_MOD;
        $auth['delete'] = ($perm['candeletepost']) ? $auth['delete'] : AUTH_MOD;
        $auth['vote'] = ($perm['canvote']) ? $auth['vote'] : AUTH_MOD;
        $auth['pollcreate'] = ($perm['canpostpoll']) ? $auth['pollcreate'] : AUTH_MOD;
        $auth['attachments'] = ($perm['canpostattachment']) ? $auth['attachments'] : AUTH_MOD;
      }
    }
    
    // Will let forum sync at the end handle this
    $lastpost = 0;
    
    $sql = "INSERT INTO " . FORUMS_TABLE . " (forum_id, cat_id, forum_name, forum_desc, forum_status, 
              forum_order, forum_posts, forum_topics, forum_last_post_id, prune_next, 
              prune_enable, auth_view, auth_read, auth_post, auth_reply, auth_edit, 
              auth_delete, auth_sticky, auth_announce, auth_vote, auth_pollcreate, auth_attachments) 
            VALUES ($forum[forumid], $catid, '".addslashes($forum['title'])."', '".addslashes($forum['description'])."', $forum_status,
              $forum[displayorder], $forum[replycount], $forum[threadcount], $lastpost, 0,
              0, $auth[view], $auth[read], $auth[post], $auth[reply], $auth[edit],
              $auth[delete], $auth[sticky], $auth[announce], $auth[vote], $auth[pollcreate], $auth[attachments])";
    $db->sql_query($sql) or die_nice("Unable to insert forum (".$forum['title'].")");
  }

  print " <span class=\"ok\"><b>OK</b></span><br />\n";

  next_step("users");
}

///////////////////////////////////////////////////////////////////////////////
// CONVERT USERS
///////////////////////////////////////////////////////////////////////////////
if ($step == "all" or $step == "users") {
  print "* Deleting existing users :: ";
  flush();
  $db->sql_query("DELETE FROM " . USERS_TABLE . " WHERE user_id != -1") or die_nice("Delete users from table ".USERS_TABLE." failed");
  $db->sql_query("DELETE FROM " . USER_GROUP_TABLE . " WHERE user_id != -1") or die_nice("Delete users from table ".USER_GROUP_TABLE." failed");
  print " <span class=\"ok\"><b>OK</b></span><br />\n";
  
  list($maxid) = $DB_site->query_first("SELECT MAX(userid) FROM user") or die_nice("Unable to query max userid");
  
  $startid = 0;
  $endid = $begin + $batchsize;
  
  // default settings for users
  $style = $board_config['default_style'];
  $lang = $board_config['default_lang'];
  $dateformat = $board_config['default_dateformat'];
  $allowhtml = $board_config['allow_html'];
  $allowbbcode = $board_config['allow_bbcode'];
  $allowsmile = $board_config['allow_smilies'];
  $allowsig = $board_config['allow_sig'];
  $allowavatar = $board_config['allow_avatar_local'] or $board_config['allow_avatar_remote'] or $board_config['allow_avatar_upload'];
  $allowpm = !$board_config['privmsg_disable'];
  
  while ($endid <= $maxid + $batchsize) {
		print " * Importing Users ( $startid to $endid ) :: ";
		flush();

    $sql = "SELECT u.*,uf.field2 AS location, uf.field3 AS interests, uf.field4 AS occupation 
            FROM user u LEFT JOIN userfield uf ON u.userid=uf.userid 
            WHERE u.userid 
              BETWEEN $startid AND $endid 
            ORDER BY u.userid ASC";
    $users_query = $DB_site->query($sql) or die_nice("Unable to query batch ( $startid - $endid )");

		$per_pct = ceil($DB_site->num_rows($users_query) / 40);
		$inc = 0;

    while ($user = $DB_site->fetch_array($users_query)) {
      
      // rank
      $user_rank = ($user['customtitle']) ? $user['customtitle'] : $user['usertitle'];
      
      // convert user level
      switch ($user['usergroupid']) {
        case 1:
          $userlevel = ANONYMOUS;
          $active = 0;
          break;
        case 2:
          $userlevel = USER;
          $active = 1;
          break;
        case 3:
          $userlevel = USER;
          $active = 0;
          break;
        case 4:
          $userlevel = USER;
          $active = 0;
          break;
        case 5:
          $userlevel = MOD;
          $active = 1;
          $groups['super_mods'][] = $user['userid'];
          break;
        case 6:
          $userlevel = ADMIN;
          $active = 1;
          $groups['admins'][] = $user['userid'];
          break;
        case 7:
          $userlevel = MOD;
          $active = 1;
          break;
        default:
          // unknown usergroup
          $userlevel = USER;
          $active = 1;
          $groups[$user['usergroupid']][] = $user['userid'];
          break;
      }
      
      // Do custom rank
      $rank_query = $db->sql_query("SELECT rank_id, rank_special FROM " . RANKS_TABLE . " WHERE rank_title='$user_rank'") or die_nice("Unable to query rankid for rank $user_rank");
      if (!(list($rankid,$rankspecial) = $db->sql_fetchrow($rank_query))) {
        // non-existing rank
        $db->sql_query("INSERT INTO " . RANKS_TABLE . " (rank_title, rank_special) VALUES ('$user_rank', 1)") or die_nice("Unable to insert new rank ($user_rank)");
        $rankid = $db->sql_nextid();
      }
      elseif ($rankspecial == 0) {
        $rankid = 'NULL';
      }
      
      // Do avatar (check if gallery avatar or normal avatar)
      if (!$user['avatarid']) {
        // normal avatar
        $avatar_query = $DB_site->query("SELECT avatardata FROM customavatar WHERE userid=".$user['userid']) or die_nice("Unable to query avatar data for user ".$user['userid']);
        list($avatar_data) = $DB_site->fetch_array($avatar_query);
        if (strlen($avatar_data) > 0) {
        
          // code taken from profile.php
          // build avatar image from database
			  	$tmp_filename = tempnam ("/tmp", $user['userid'] . "gif");
			  	$fptr = @fopen($tmp_filename, "wb");
			  	$bytes_written = @fwrite($fptr, $avatar_data, strlen($avatar_data));
			  	@fclose($fptr);
			  	$avatar_filename = $user['userid'] . ".gif";
			  	if( file_exists( PHPBB_PATH . $board_config['avatar_path'] . "/$avatar_filename" ) ) {
			  		@unlink( PHPBB_PATH . $board_config['avatar_path'] . "/$avatar_filename" );
			  	}
			  	@copy($tmp_filename, PHPBB_PATH . $board_config['avatar_path'] . "/$avatar_filename");
			  	@unlink($tmp_filename);
			  	$avatar = $avatar_filename;
			  	$avatar_type = USER_AVATAR_UPLOAD;
        }
        else {
          // no avatar
          $avatar = '';
          $avatar_type = USER_AVATAR_NONE;
        }
      }
      else {
        // gallery avatar
        $avatar_query = $DB_site->query("SELECT avatarpath FROM avatar WHERE avatarid=".$user['avatarid']) or die_nice("Unable to query gallery avatar data (".$user['avatarid'].")");
        list($avatar_path) = $DB_site->fetch_array($avatar_query);
        if (substr($avatar_path,0,15) == 'images/avatars/') {
          $path = substr($avatar_path,15);
          $dirname = dirname($path);
          if ($dirname == ".") {
            $dirname = "default";
          }
          $filename = basename($path);
          $avatar = $dirname . "/" . $filename;
          $avatar_type = USER_AVATAR_GALLERY;
        }
        else {
          $avatar = '';
          $avatar_type = USER_AVATAR_NONE;
        }
      }
      
      // Do signature
      $siguid = ( $allowbbcode ) ? make_bbcode_uid() : "";
      $signature = prepare_message($user['signature'], $allowhtml, $allowbbcode, $allowsmilies, $siguid);

      // Do some checks on the data
			$user['yahoo'] = strlen($user['yahoo']) < 3 ? '' : $user['yahoo'];
			$user['aim'] = strlen($user['aim']) < 3 ? '' : $user['aim'];

			$website = trim($user['homepage']);
			if ( substr(strtolower($website), 0, 7) != "http://" ) {
				$website = "http://" . $website;
			}
			if( strtolower($website) == 'http://' ) {
				$website = '';
			}
			$user['homepage'] = $website;
			
			$user['icq'] = (ereg("^[0-9]+$", $user['icq'])) ? $user['icq'] : '';

      // User insert
      $query = "INSERT INTO " . USERS_TABLE . " (user_id, user_active, username, user_password, 
                  user_lastvisit, user_regdate, user_level, user_posts, user_timezone, user_style, 
                  user_lang, user_dateformat, user_viewemail, user_attachsig, user_allowhtml, 
                  user_allowbbcode, user_allowsmile, user_allowavatar, user_allow_pm, 
                  user_allow_viewonline, user_notify, user_notify_pm, user_popup_pm, user_rank, user_avatar, 
                  user_avatar_type, user_email, user_icq, user_website, user_from, user_sig, user_sig_bbcode_uid, 
                  user_aim, user_yim, user_msnm, user_occ, user_interests)
                VALUES (
                  $user[userid], $active, '" . addslashes($user[username]) . "', '" . addslashes($user[password]) . "', 
                  $user[lastvisit], $user[joindate], $userlevel, $user[posts], '" . addslashes($user[timezoneoffset]) . "', $style,
                  '$lang', '".addslashes($dateformat)."', $user[showemail], $allowsig, $allowhtml,
                  $allowbbcode, $allowsmile, $allowavatar, $allowpm, 
                  !$user[invisible], $user[emailnotification], $user[emailonpm], $user[pmpopup], $rankid, '" . addslashes($avatar) . "',
                  $avatar_type, '" . addslashes($user[email]) . "', '" . addslashes($user[icq]) . "', '" . addslashes($user[homepage]) . "', '" . addslashes($user['location']) . "', '" . addslashes($signature) . "', '$siguid',
                  '" . addslashes($user['aim']) . "', '" . addslashes($user['yahoo']) . "', '', '" . addslashes($user['occupation']) . "', '" . addslashes($user['interests']) . "')";

			$db->sql_query($query) or die_nice("Unable to insert user ".$user['userid']." into table ".USERS_TABLE);

      // Group creation
			$query = "INSERT INTO " . GROUPS_TABLE . " (group_name, group_description, group_single_user) 
						    VALUES ('" . addslashes($user['username']) . "', 'Personal User', 1)";
			$db->sql_query($query) or die_nice("Unable to insert user ".$user['userid']." into table ".GROUPS_TABLE);
			$group_id = $db->sql_nextid();
			
			// User -> Group creation
			$query = "INSERT INTO " . USER_GROUP_TABLE . " (group_id, user_id, user_pending)	
						  	VALUES ($group_id, " . $user['userid'] . ", 0)";
			$db->sql_query($query) or die_nice("Unable to insert user ".$user['userid']." into table ".USER_GROUP_TABLE);

			$inc++;
			if ( $inc == $per_pct ) {
				print ".";
				flush();
				$inc = 0;
			}

    }

  	print " <span class=\"ok\"><b>OK</b></span><br />\n";
  
    $startid = $endid + 1;
    $endid = $startid + $batchsize;
  }


	// handle super-mods and admins, create groups for them
	if( count($groups['super_mods']) && count($groups['admins']) )
	{
		print " * Creating new group for admins and super moderators :: ";
		flush();

		$sql = "INSERT INTO " . GROUPS_TABLE . " (group_type, group_name, group_description, group_moderator, group_single_user)
			VALUES (" . GROUP_HIDDEN . ", 'Super Moderators', 'Converted super moderators', " . $groups['admins'][0] . ", 0)";
		$result = $db->sql_query($sql) or die_nice("Couldn't create group for Super Moderators");

    $mods_group_id = $db->sql_nextid();

		$sql = "INSERT INTO " . GROUPS_TABLE . " (group_type, group_name, group_description, group_moderator, group_single_user)
			VALUES (" . GROUP_HIDDEN . ", 'Administrators', 'Converted administrators', " . $groups['admins'][0] . ", 0)";
		$result = $db->sql_query($sql) or die_nice("Couldn't create group for Administrators");

		$admins_group_id = $db->sql_nextid();

		print " <span class=\"ok\"><b>OK</b></span><br />\n";

		print " * Updating auth_access for super moderator group :: ";
		flush();

		$sql = "SELECT forum_id 
			FROM " . FORUMS_TABLE;
		$result = $db->sql_query($sql) or die_nice("Couldn't obtain forum_id list");

		while( $row = $db->sql_fetchrow($result) )
		{
			$sql = "INSERT INTO " . AUTH_ACCESS_TABLE . " (group_id, forum_id, auth_mod)
				VALUES ($mods_group_id, " . $row['forum_id'] . ", 1)";
			$db->sql_query($sql) or die_nice("Unable to set group auth access for super mods.");
		}
		print " <span class=\"ok\"><b>OK</b></span><br />\n";

		print " * Populating admin and super moderator groups :: ";
		flush();

		for($i = 0; $i < count($groups['super_mods']); $i++)
		{
			$sql = "INSERT INTO " . USER_GROUP_TABLE . " (group_id, user_id, user_pending)
				VALUES ($mods_group_id, " . $groups['super_mods'][$i] . ", 0)";
			$db->sql_query($sql) or die_nice("Unable to add user_id ".$groups['super_mods'][$i]." to group_id $mods_group_id (super mods)");
		}

		for($i = 0; $i < count($groups['admins']); $i++)
		{
			$sql = "INSERT INTO " . USER_GROUP_TABLE . " (group_id, user_id, user_pending)
				VALUES ($admins_group_id, " . $groups['admins'][$i] . ", 0)";
			$db->sql_query($sql) or die_nice("Unable to add user_id ".$groups['admins'][$i]." to group_id $admins_group_id (admins)");
		}
	
		print " <span class=\"ok\"><b>OK</b></span><br />\n";
		flush();
	}
	
	// create groups from custom vB usergroups
	print " * Importing custom vB usergroups and permissions :: ";
	flush();
	while (list($groupid,$group_members) = each($groups)) {
	  if ($groupid == "admins" or $groupid == "super_mods") {
	    continue;
	  }
	  
	  // get data
	  $sql = "SELECT * FROM usergroup WHERE usergroupid = $groupid";
	  $group_data = $DB_site->query_first($sql);
	  
	  // create group
	  $group_type = ($group_data['showgroup']) ? GROUP_CLOSED : GROUP_HIDDEN;
		$sql = "INSERT INTO " . GROUPS_TABLE . " (group_type, group_name, group_description, group_moderator, group_single_user)
			VALUES (" . $group_type . ", '" . addslashes($group_data['title']) . "', '" . addslashes($group_data['title']) . "', " . $group_members[0] . ", 0)";
		$db->query($sql) or die_nice("Couldn't create group ".$group_data['title']);
		$new_group_id = $db->sql_nextid();
	  
	  // populate group
		for($i = 0; $i < count($group_members); $i++) {
			$sql = "INSERT INTO " . USER_GROUP_TABLE . " (group_id, user_id, user_pending)
				VALUES ($new_group_id, " . $group_members[$i] . ", 0)";
			$db->sql_query($sql) or die_nice("Unable to add user_id ".$group_members[$i]." to group_id $new_group_id");
		}
		
		// do permissions
		$sql = "SELECT forum_id FROM " . FORUMS_TABLE;
		$forums = $db->sql_query($sql) or die ("Unable to fetch forumids for usergroup permissions");
		@reset($forums);
		while (list($forumid) = $db->sql_fetchrow($forums)) {
		  // check if forum has custom permissions
		  $permissions = $DB_site->query_first("SELECT * FROM forumpermissions WHERE usergroupid=$groupid AND forumid=$forumid") or die_nice("Unable to fetch forumpermissions for usergroup");
		  if (count($permissions)) {
		    // custom permissions, use these
		    $sql = "INSERT INTO " . AUTH_ACCESS_TABLE . " (group_id, forum_id, auth_view, auth_read, auth_post,  
		              auth_reply, auth_edit, auth_delete, auth_sticky, auth_announce, auth_vote, 
		              auth_pollcreate, auth_attachments, auth_mod)
		            VALUES ($new_group_id, $forumid, $permissions[canview], $permissions[canview], $permissions[canpostnew],
		              $permissions[canreplyothers], $permissions[caneditpost], $permissions[candeletepost], 0, $permissions[canvote],
		              $permissions[canpostpoll], $permissions[canpostattachment], $group_data[ismoderator])";
		  }
		  else {
		    // use usergroup standard permissions
		    $sql = "INSERT INTO " . AUTH_ACCESS_TABLE . " (group_id, forum_id, auth_view, auth_read, auth_post,  
		              auth_reply, auth_edit, auth_delete, auth_sticky, auth_announce, auth_vote, 
		              auth_pollcreate, auth_attachments, auth_mod)
		            VALUES ($new_group_id, $forumid, $group_data[canview], $group_data[canview], $group_data[canpostnew],
		              $group_data[canreplyothers], $group_data[caneditpost], $group_data[candeletepost], 0, $group_data[canvote],
		              $group_data[canpostpoll], $group_data[canpostattachment], $group_data[ismoderator])";
		  }
		  $db->sql_query($sql) or die_nice("Unable to insert forumpermissions for usergroup");
		}
		
  }
  print " <span class=\"ok\"><b>OK</b></span><br />\n";

  // Moderators convert
  print " * Converting moderators :: ";
  flush();
  $user_mods = array();
  $moderators = $DB_site->query("SELECT userid, forumid FROM moderator") or die_nice("Unable to get moderators");
  while (list($userid,$forumid) = $DB_site->fetch_array($moderators)) {
    $user_mods[] = $userid;
    $group_query = $db->sql_query("SELECT group_id FROM " . USER_GROUP_TABLE . " WHERE user_id=".$userid) or die_nice("Unable to get group_id for user");
    list($groupid) = $db->sql_fetchrow($group_query);
    $db->sql_query("INSERT INTO " . AUTH_ACCESS_TABLE . " (group_id, forum_id, auth_mod) VALUES ($groupid, $forumid, 1)") or die_nice("Unable to insert moderators");
  }
  // Update user_level for users that are moderator
  if (count($user_mods)) {
	  $sql = "UPDATE " . USERS_TABLE . " 
      		    SET user_level = " . MOD . " 
		          WHERE user_id IN (" . implode(", ", $user_mods) . ") AND user_level <> " . ADMIN; 
	  $db->sql_query($sql) or die_nice("Couldn't update user levels to moderator");
	}

  print " <span class=\"ok\"><b>OK</b></span><br />\n";
  
  // Banned users convert
  print " * Converting banned users :: ";
  flush();
  $query = "INSERT INTO " . BANLIST_TABLE . " (ban_userid) 
            SELECT user_id FROM " . USERS_TABLE . " WHERE user_active=0 AND user_id!=-1";
  $db->sql_query($query);
  print " <span class=\"ok\"><b>OK</b></span><br />\n";
  flush();
  
  next_step("topics");
}

///////////////////////////////////////////////////////////////////////////////
// CONVERT TOPICS
///////////////////////////////////////////////////////////////////////////////
if ($step == "all" or $step == "topics") {
  print "* Deleting existing topics :: ";
  flush();
  
  $query = "DELETE FROM " . TOPICS_TABLE;
  $db->sql_query($query) or die_nice("Unable to delete $query");
  print " <span class=\"ok\"><b>OK</b></span><br />\n";

  $query = "SELECT MAX(threadid) FROM thread";
  list($maxid) = $DB_site->query_first($query) or die_nice("Unable to get maximum threadid");

  $beginid = 0;
  $endid = $beginid + $batchsize;

  while ($endid <= $maxid + $batchsize) {
    print "* Importing topics ( $beginid to $endid ) :: ";
    flush();

    $sql = "SELECT * FROM thread WHERE (threadid BETWEEN $beginid AND $endid) AND visible=1 ORDER BY threadid ASC";
    $thread_query = $DB_site->query($sql) or die_nice("Unable to get topics");

		$per_pct = ceil($DB_site->num_rows($thread_query) / 40);
		$inc = 0;

    while ($thread = $DB_site->fetch_array($thread_query)) {
      $topic_id = $thread['threadid'];
      $forum_id = $thread['forumid'];
      $title = addslashes($thread['title']);
      $replies = $thread['replycount'];
      $time = $thread['dateline'];
      $views = $thread['views'];
      $type = ($thread['sticky']) ? POST_STICKY : POST_NORMAL;

      switch ($thread['open']) {
        case 0:
          $status = TOPIC_LOCKED;
          $moved = 0;
          $vote = ($thread['pollid']) ? 1 : 0;
          break;
        case 1:
          $status = TOPIC_UNLOCKED;
          $vote = ($thread['pollid']) ? 1 : 0;
          $moved = 0;
          break;
        case 10:
          $status = TOPIC_MOVED;
          $moved = $thread['pollid'];
          break;
      }

      $poster = $thread['postuserid'];

      // get correct topic_id even if topic is moved
      // this will get messy if topic is moved more than once...
      $post_topic_id = ($status == TOPIC_MOVED) ? $moved : $topic_id;
      
      $sql = "SELECT MIN(postid) AS firstpostid, MAX(postid) AS lastpostid FROM post WHERE threadid=".$post_topic_id." GROUP BY threadid";
      $post_query = $DB_site->query($sql) or die_nice("Unable to get first and last postid for topic: $post_topic_id");
      $row = $DB_site->fetch_array($post_query);
      $firstpostid = (int) $row['firstpostid'];
      $lastpostid = (int) $row['lastpostid'];
      
      $sql = "INSERT INTO " . TOPICS_TABLE . " 
               (topic_id, forum_id, topic_title, topic_poster, topic_time, topic_views, topic_replies,
                topic_status, topic_vote, topic_type, topic_first_post_id, topic_last_post_id, topic_moved_id)
              VALUES 
               ($topic_id, $forum_id, '$title', $poster, $time, $views, $replies,
                $status, $vote, $type, $firstpostid, $lastpostid, $moved)";
      $db->sql_query($sql) or die_nice("Unable to insert topic (".$topic_id.")");
      
 			$inc++;
			if ( $inc == $per_pct ) {
				print ".";
				flush();
				$inc = 0;
			}
    }  
    print " <span class=\"ok\"><b>OK</b></span><br />\n";

    $beginid = $endid + 1;
    $endid = $beginid + $batchsize;
  }
  
  // topic watch list
  print "* Importing topic watch list :: ";
  flush();
  $subscribe_query = $DB_site->query("SELECT * FROM subscribethread") or die_nice("Unable to query watch list info");
  while ($subscribe = $DB_site->fetch_array($subscribe_query)) {
    $topic_id = $subscribe['topic_id'];
    $user_id = $subscribe['user_id'];
    $sql = "INSERT INTO " . TOPICS_WATCH_TABLE . " (topic_id, user_id)
            VALUES ($topic_id, $user_id)";
  }
  print " <span class=\"ok\"><b>OK</b></span><br />\n";

  next_step("posts");

}

///////////////////////////////////////////////////////////////////////////////
// CONVERT POSTS
///////////////////////////////////////////////////////////////////////////////
if ($step == "all" or $step == "posts") {
  print "* Deleting existing posts :: ";
  flush();
  $db->sql_query("DELETE FROM ".POSTS_TABLE) or die_nice("Unable to delete existing posts");
  $db->sql_query("DELETE FROM ".POSTS_TEXT_TABLE) or die_nice("Unable to delete existing posts");
  print " <span class=\"ok\"><b>OK</b></span><br />\n";
  
  $sql = "SELECT MAX(postid) FROM post";
  list($maxid) = $DB_site->query_first($sql) or die_nice("Unable to fetch maximum postid");

  $beginid = 0;
  $endid = $beginid + $batchsize;

  $allowhtml = $board_config['allow_html'];
  $allowbbcode = $board_config['allow_bbcode'];
  
  // Get the quote template and modify it
  $quote_template = gettemplate('quotereply',0,0);
  $quote_template = str_replace("\n","\r\n", $quote_template);
  $quote_template = preg_quote($quote_template);
  $quote_template = str_replace("\\\$originalposter","(.*)",$quote_template);
  $quote_template = explode("\\\$pagetext",$quote_template);
  $quote_template[0] = "|".trim($quote_template[0])."|isU";
  $quote_template[1] = "|".trim($quote_template[1])."|isU";

  while ($endid <= $maxid + $batchsize) {
    print "* Importing posts ($beginid to $endid) :: ";
    flush();
    
    $sql = "SELECT p.*,t.forumid 
            FROM post p LEFT JOIN thread t ON p.threadid=t.threadid 
            WHERE (p.postid BETWEEN $beginid AND $endid) 
            ORDER BY p.postid ASC";
    $posts_query = $DB_site->query($sql) or die_nice("Unable to select batch posts");

		$per_pct = ceil($DB_site->num_rows($posts_query) / 40);
		$inc = 0;
    
    while ($post = $DB_site->fetch_array($posts_query)) {

      $ip = encode_ip($post['ipaddress']);
      
      $edited = ($post['editdate']) ? 1 : 0;

      // do general postinfo
      $sql = "INSERT INTO " . POSTS_TABLE . " 
               (post_id, topic_id, forum_id, poster_id, post_time, poster_ip, 
                post_username, enable_bbcode, enable_html, enable_smilies, enable_sig,
                post_edit_time, post_edit_count)
              VALUES ($post[postid], $post[threadid], $post[forumid], $post[userid], $post[dateline], '$ip',
                '".addslashes($post['username'])."', $allowbbcode, $allowhtml, $post[allowsmilie], $post[showsignature],
                $post[editdate], $edited)";
      $db->sql_query($sql) or die_nice("Unable to insert general postinfo for postid ".$post['postid']);
                
      // do posttext
      $post_id = $post['postid'];
      $bbcode_uid = make_bbcode_uid();
      $post_subject = addslashes($post['title']);
      
      // convert vB bbcode to phpBB bbcode
      $post_text = addslashes(convert_vb_code($post['pagetext'], $quote_template));
      
      $post_text = prepare_message($post_text, $allowhtml, $allowbbcode, $post['allowsmilies'], $bbcode_uid);
      
      $sql = "INSERT INTO " . POSTS_TEXT_TABLE . " (post_id, bbcode_uid, post_subject, post_text)
              VALUES 
               ($post_id, '$bbcode_uid', '$post_subject', '$post_text')";
      $db->sql_query($sql) or die_nice("Unable to insert post text for post $post_id");
      
 			$inc++;
			if ( $inc == $per_pct ) {
				print ".";
				flush();
				$inc = 0;
			}
    }
    
    print " <span class=\"ok\"><b>OK</b></span><br />\n";

    $beginid = $endid + 1;
    $endid = $beginid + $batchsize;
  }

  // Do announcements
  print "* Importing announcements :: ";

  $sql = "SELECT a.*,u.username FROM announcement a LEFT JOIN user u ON a.userid=u.userid";
  $announce_query = $DB_site->query($sql) or die_nice("Unable to fetch announcements");

  while ($announcement = $DB_site->fetch_array($announce_query)) {
    
    // get forum(s) where this announcement should be in
    $forum_ids = array();
    if ($announcement['forumid'] == -1) {
      $sql = "SELECT forum_id FROM " . FORUMS_TABLE;
      $forum_query = $db->sql_query($sql) or die_nice("Unable to query forum ids");
      while ($forum = $db->sql_fetchrow($forum_query)) {
        $forum_ids[] = $forum['forum_id'];
      }
    }
    else {
      $forum_ids[] = $announcement['forumid'];
    }
    @reset($forum_ids);
    
    $title = addslashes($announcement['title']);
    $type = POST_ANNOUNCE;
    $status = TOPIC_LOCKED;
    $bbcode_uid = make_bbcode_uid();
    $post_text = addslashes(convert_vb_code($announcement['pagetext']));
    $post_text = prepare_message($post_text, 1, 1, 1, $bbcode_uid);

    // loop all forums in forum_ids
    while (list($i,$forum_id) = each($forum_ids)) {

      // make topic
      $sql = "INSERT INTO " . TOPICS_TABLE . " 
               (forum_id, topic_title, topic_poster, topic_time, topic_status, 
                topic_vote, topic_type, topic_first_post_id, topic_last_post_id, topic_moved_id)
              VALUES 
               ($forum_id, '$title', $announcement[userid], $announcement[startdate], 
                $status, 0, $type, 0, 0, 0)";
      $db->sql_query($sql) or die_nice("Unable to insert announcement topic (".$announcement['announcementid'].")");
      $topic_id = $db->sql_nextid();
      
      // make postinfo
      $sql = "INSERT INTO " . POSTS_TABLE . " 
               (topic_id, forum_id, poster_id, post_time, 
                post_username, enable_bbcode, enable_html, enable_smilies, enable_sig)
              VALUES ($topic_id, $forum_id, $announcement[userid], $announcement[startdate], 
                '".addslashes($announcement['username'])."', 1, 1, 1, 0)";
      $db->sql_query($sql) or die_nice("Unable to insert general postinfo for announcement ".$announcement['announcementid']);
      $post_id = $db->sql_nextid();
      
      $sql = "INSERT INTO " . POSTS_TEXT_TABLE . " (post_id, bbcode_uid, post_subject, post_text)
              VALUES 
               ($post_id, '$bbcode_uid', '$title', '$post_text')";
      $db->sql_query($sql) or die_nice("Unable to insert post text for announcement ".$announcement['announcementid']);
      
      // Update first_post_id and last_post_id
      $sql = "UPDATE " . TOPICS_TABLE . " SET topic_first_post_id = $post_id, topic_last_post_id = $post_id WHERE topic_id = $topic_id";
      $db->sql_query($sql) or die_nice("Unable to update first and last postid for announcement ".$announcement['announcementid']);
      
    }
  }
  print " <span class=\"ok\"><b>OK</b></span><br />\n";

  next_step("polls");
}

///////////////////////////////////////////////////////////////////////////////
// CONVERT POLLS
///////////////////////////////////////////////////////////////////////////////
if ($step == "all" or $step == "polls") {
  print "* Deleting existing polls :: ";
  flush();
  $db->sql_query("DELETE FROM " . VOTE_DESC_TABLE) or die_nice("Unable to delete existing poll descriptions");
  $db->sql_query("DELETE FROM " . VOTE_RESULTS_TABLE) or die_nice("Unable to delete existing poll results");
  $db->sql_query("DELETE FROM " . VOTE_USERS_TABLE) or die_nice("Unable to delete existing poll users");
  print " <span class=\"ok\"><b>OK</b></span><br />\n";

  $sql = "SELECT MAX(pollid) FROM poll";
  list($maxid) = $DB_site->query_first($sql) or die_nice("Unable to fetch maximum pollid");

  $beginid = 0;
  $endid = $beginid + $batchsize;
  
  while ($endid <= $maxid + $batchsize) {
    print "* Importing polls ($beginid to $endid) :: ";
    flush();

    $sql = "SELECT p.*,t.threadid 
            FROM poll p LEFT JOIN thread t ON t.pollid=p.pollid 
            WHERE (t.open<>10 AND p.pollid BETWEEN $beginid AND $endid) 
            ORDER BY p.pollid";
    $polls_query = $DB_site->query($sql) or die_nice("Unable to select batch of polls");

		$per_pct = ceil($DB_site->num_rows($polls_query) / 40);
		$inc = 0;
    
    while ($poll = $DB_site->fetch_array($polls_query)) {
      
      // convert from days to seconds
      $poll_length = $poll['timeout'] * 86400;
      
      // description
      $sql = "INSERT INTO " . VOTE_DESC_TABLE . " (vote_id, topic_id, vote_text, vote_start, vote_length) 
              VALUES ($poll[pollid], $poll[threadid], '".addslashes($poll['question'])."', $poll[dateline], $poll_length)";
      $db->sql_query($sql) or die_nice("Unable to insert poll desc (".$poll['pollid'].")");

      // options
      $options = explode("|||",$poll['options']);
      $votes = explode("|||",$poll['votes']);
      $sql = "INSERT INTO " . VOTE_RESULTS_TABLE . " (vote_id, vote_option_id, vote_option_text, vote_result) VALUES ";
      for ($i=0; $i<count($options); $i++) {
        $optionid = $i + 1;
        $optiontext = addslashes(trim($options[$i]));
        $optionresults = (int) $votes[$i];
        $sql .= "($poll[pollid], $optionid, '$optiontext', $optionresults),";
      }
      $sql = substr($sql,0,-1);
      $db->sql_query($sql) or die_nice("Unable to insert poll options (".$poll['pollid'].")");

      // voters
      $user_query = $DB_site->query("SELECT userid FROM pollvote WHERE pollid=".$poll['pollid']);
      if ($DB_site->num_rows($user_query)) {
        $sql = "INSERT INTO " . VOTE_USERS_TABLE . " (vote_id, vote_user_id) VALUES ";
        while (list($userid) = $DB_site->fetch_array($user_query)) {
          $sql .= "($poll[pollid], $userid),";
        }
        $sql = substr($sql,0,-1);
        $db->sql_query($sql) or die_nice("Unable to insert poll voters (".$poll['pollid'].")");
      }
    
 			$inc++;
			if ( $inc == $per_pct ) {
				print ".";
				flush();
				$inc = 0;
			}
    }
    
    print " <span class=\"ok\"><b>OK</b></span><br />\n";

    $beginid = $endid + 1;
    $endid = $beginid + $batchsize;
  }

  next_step("pm");
}

///////////////////////////////////////////////////////////////////////////////
// CONVERT PRIVATE MESSAGES
///////////////////////////////////////////////////////////////////////////////
if ($step == "all" or $step == "pm") {
  print "* Deleting existing private messages :: ";
  flush();
  $db->sql_query("DELETE FROM " . PRIVMSGS_TABLE) or die_nice("Unable to delete existing private messages");
  $db->sql_query("DELETE FROM " . PRIVMSGS_TEXT_TABLE) or die_nice("Unable to delete existing private messages text");
  print " <span class=\"ok\"><b>OK</b></span><br />\n";

  $sql = "SELECT MAX(privatemessageid) FROM privatemessage";
  $maxid_query = $DB_site->query($sql) or die_nice("Unable to fetch maximum private message id");
  list($maxid) = $DB_site->fetch_array($maxid_query);

  $allowhtml = $board_config['allow_html'];
  $allowbbcode = $board_config['allow_bbcode'];
  define ("VB_INBOX", 0);
  define ("VB_SENTBOX", -1);

  $beginid = 0;
  $endid = $beginid + $batchsize;
  
  while ($endid <= $maxid + $batchsize) {
    print "* Importing private messages ($beginid to $endid) :: ";
    flush();

    $sql = "SELECT * FROM privatemessage WHERE privatemessageid BETWEEN $beginid AND $endid";
    $pm_query = $DB_site->query($sql) or die_nice("Unable to select batch of private messages");

		$per_pct = ceil($DB_site->num_rows($pm_query) / 40);
		$inc = 0;
    
    while ($pm = $DB_site->fetch_array($pm_query)) {
      
      // Determine message type
      // If message is in INBOX, it can be either READ or UNREAD
      // If message is in SENTBOX, it is saved accordingly
      // No SAVEBOX exists in vB
      switch ($pm['folderid']) {
        case VB_INBOX:
          $pm_type = ($pm['messageread']) ? PRIVMSGS_READ_MAIL : PRIVMSGS_UNREAD_MAIL;
          break;
        case VB_SENTBOX:
        default:
          $pm_type = PRIVMSGS_SENT_MAIL;
          break;
      }
      
      $pm_bbcode_uid = make_bbcode_uid();
      $pm_text = addslashes(convert_vb_code($pm['message']));
      $pm_text = prepare_message($pm_text, $allowhtml, $allowbbcode, $allowbbcode, $pm_bbcode_uid);
      
      // This will reset the private message ID's
      // Since there are no links to this ID, it seems wise to restart the numbering
      // To keep the vB ID's, uncomment the following line, add the privmsgs_id to the query
      // and comment the $db->sql_nextid() line out:
      //$pmid = $pm['privatemessageid'];
      
      // general info
      $sql = "INSERT INTO " . PRIVMSGS_TABLE . " (privmsgs_type, privmsgs_subject, 
                privmsgs_from_userid, privmsgs_to_userid, privmsgs_date, privmsgs_enable_bbcode, 
                privmsgs_enable_html, privmsgs_enable_smilies, privmsgs_attach_sig)
              VALUES ($pm_type, '".addslashes($pm[title])."',
                $pm[fromuserid], $pm[touserid], $pm[dateline], $allowbbcode,
                $allowhtml, $allowbbcode, $pm[showsignature])";
      $db->sql_query($sql) or die_nice("Unable to insert private message (".$pm['privatemessageid'].")");
      $pmid = $db->sql_nextid();
      
      // actual message
      $sql = "INSERT INTO " . PRIVMSGS_TEXT_TABLE . " (privmsgs_text_id, privmsgs_bbcode_uid, privmsgs_text) 
              VALUES ($pmid, '$pm_bbcode_uid', '$pm_text')";
      $db->sql_query($sql) or die_nice("Unable to insert private message text (".$pm['privatemessageid'].")");

 			$inc++;
			if ( $inc == $per_pct ) {
				print ".";
				flush();
				$inc = 0;
			}
    }
    
    print " <span class=\"ok\"><b>OK</b></span><br />\n";

    $beginid = $endid + 1;
    $endid = $beginid + $batchsize;
  }

  next_step("wordlist");
}

///////////////////////////////////////////////////////////////////////////////
// GENERATE SEARCH WORDLIST
///////////////////////////////////////////////////////////////////////////////
if ($step == "all" or $step == "wordlist") {

  print "* Deleting existing wordlist :: ";
  flush();

  $db->sql_query("DELETE FROM " . SEARCH_WORD_TABLE) or die_nice("Unable to delete existing search words");
  $db->sql_query("DELETE FROM " . SEARCH_MATCH_TABLE) or die_nice("Unable to delete existing search word matches");

  print " <span class=\"ok\"><b>OK</b></span><br />\n";
  flush();

	//
	// Generate search word list (taken from upgrade.php)
	//
	// Fetch a batch of posts_text entries
	//
	$sql = "SELECT COUNT(*) as total, MAX(post_id) as max_post_id 
		FROM " . POSTS_TEXT_TABLE;
	$result = $db->sql_query($sql) or die_nice("Couldn't get post count totals");

	$max_post_id = $db->sql_fetchrow($result);

	$totalposts = $max_post_id['total'];
	$max_post_id = $max_post_id['max_post_id'];
	$per_percent = round(( $totalposts / 500 ) * 10);

	$postcounter = ( !isset($HTTP_GET_VARS['batchstart']) ) ? 0 : $HTTP_GET_VARS['batchstart'];

	$batchsize = 150; // Process this many posts per loop
	$batchcount = 0;
	$total_percent = 0;

	for(;$postcounter <= $max_post_id; $postcounter += $batchsize)
	{
		$batchstart = $postcounter + 1;
		$batchend = $postcounter + $batchsize;
		$batchcount++;

		print " * Fulltext Indexing ( $batchstart to $batchend ) :: ";
		flush();
		
		$sql = "SELECT *
			FROM " . POSTS_TEXT_TABLE ."
			WHERE post_id 
				BETWEEN $batchstart 
					AND $batchend";
		$posts_result = $db->sql_query($sql) or die_nice("Couldn't obtain post_text");

		$per_pct = ceil( $db->sql_numrows($posts_result) / 40 );
		$inc = 0;

		if ( $row = $db->sql_fetchrow($posts_result) )
		{ 
			do
			{
				add_search_words($row['post_id'], $row['post_text'], $row['post_subject']);

				$inc++;
				if ( $inc == $per_pct )
				{
					print ".";
					flush();
					$inc = 0;
				}
			}
			while( $row = $db->sql_fetchrow($posts_result) );
		}

		$db->sql_freeresult($posts_result);
		
		// Remove common words after the first 2 batches and after every 4th batch after that.
		if ( $batchcount % 4 == 3 )
		{
			remove_common('global', 0.4);
		}

		print " <span class=\"ok\"><b>OK</b></span><br />\n";
	}
  // End taken from upgrade.php
  
  next_step("end");
}

///////////////////////////////////////////////////////////////////////////////
// FINALIZE INSTALL AND SHOW SUCCESS MESSAGE
///////////////////////////////////////////////////////////////////////////////
if ($step == "all" or $step == "end") {
      
  // Do some things that didn't fit into any other category
  // or have to be done last

  echo "* Finalizing installation :: ";
  flush();

	// Find board startdate
	$sql = "SELECT MIN(user_regdate) AS oldest_time
		FROM " . USERS_TABLE . " 
		WHERE user_regdate > 0";
	$result = $db->sql_query($sql) or die_nice("Couldn't obtain oldest post time");
	$row = $db->sql_fetchrow($result);

	$sql = "UPDATE " . CONFIG_TABLE . " SET config_value = " . $row['oldest_time'] . " WHERE config_name = 'board_startdate'";
	$db->sql_query($sql) or die_nice("Couldn't update board_startdate: $sql");
	
	// Sync all forums
	sync('all forums',0);

	//
	// Change session table to HEAP if MySQL version matches
	//
	$sql = "SELECT VERSION() AS mysql_version";
	$result = $db->sql_query($sql) or die_nice("Couldn't obtain MySQL Version");

	$row = $db->sql_fetchrow($result);

	$version = $row['mysql_version'];

	if ( preg_match("/^(3\.23)|(4\.)/", $version) )
	{
		$sql = "ALTER TABLE " . SESSIONS_TABLE . " TYPE=HEAP";
		$db->sql_query($sql) or die_nice("Couldn't alter sessions table to HEAP");
	}

	echo " <span class=\"ok\"><b>OK</b></span><br />\n";
	
	// Display DONE HTML message
	// Thank user
	print "<br clear=\"all\" /><br />\n";
	print "<b>Import successfull.</b><br />\n";
	print "<a target=\"_blank\" href=\"".PHPBB_URI."\">Your board</a> is now converted. Please check all settings in <a target=\"_blank\" href=\"".PHPBB_URI."admin/\">the control panel</a>. You can login with any old admin user / password combination of you vBulletin installation. The standard phpBB admin account is deleted. Be sure to remove or disable this import script, as it can distory the entire new phpBB installation!<br /><br />\n";
	print "Thank you for using this Conversion Tool by <a target=\"_blank\" href=\"http://matthijs.beryllium.net/\">Matthijs van de Water</a>. If you are happy with the results, drop me <a href=\"mailto:matthijs@beryllium.net\">an email</a> to thank me. If you have to much money, you can always buy something from <a target=\"_amazon\" href=\"http://www.amazon.com/exec/obidos/wishlist/38CDOU6HA0TUX\">my Amazon Wish List</a> ;)<br />\n";
	print "<br />\n<hr />\n";
  
  common_footer();
}

?>